

// this function approximates the zero of a function using bisection
function x0 = dichoto(f, a, b, nbetap)
    
fa = f(a);
fb = f(b);
if fa*fb>0
    error('failure: f has same sign in a and b');    
end   
 
x0=zeros(nbetap,1);    
for k=1:nbetap
    c=(a+b)/2;
    fc = f(c);
    //disp([a,b,c,fc])    
    if fc*fa<0
        //disp('negative')   
        b=c;
    else
        //disp('positive')   
        fa=fc;
        a=c;
    end    
    x0(k)=c;    
end    

end



function xs = secante(f, x0, x1, nbetap)  
xs=zeros(nbetap,1); 
xs(1)=x0;
xs(2)=x1;
for k=2:nbetap-1
    xs(k+1)= xs(k) - (xs(k) - xs(k-1))/(f(xs(k)) - f(xs(k-1)))*f(xs(k));
end        
end


function xs = newton(f, df, x0, nbetap)
    
xs=zeros(nbetap,1); 
xs(1)=x0;
for k=1:nbetap-1
    xs(k+1)= xs(k) - f(xs(k))/df(xs(k));
end           
end


function ns = find_its(xs,zeta,tols)
    
N=length(tols);
ns=zeros(N,1);

if  min(abs(xs-zeta))>min(tols)
    error('target accuracy not reached')  
end

for i=1:N
    ns(i)=find(abs(xs-zeta)<tols(i),1);   
end   
    
endfunction


















